# -*- coding: utf-8 -*-

# Renamer controller
# Allows interaction with renaming panel (view)
# Handles highest level previewing and renaming of items

"""
Copyright (C) 2006-2010 ianaré sévi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

ianare@gmail.com
"""

import engine
import preview
import operations
import wxRenamerView


# needs work, obviously
class Core():
    def __init__(self, parent, MainWindow):
        global main
        main = MainWindow
        self.operations = [] # operations stack
        self.Panel = wxRenamerView.Panel(self, parent, main)
        self.Preview = preview.Core(main)
        self.Engine = engine.Core(main)


    def createOperation(self, n, opName, params={}):
        """Create a new instance of the specified operation and return it."""
        opName = operations.getInternalName(opName)
        # init operation object
        operation = getattr(operations, opName)
        # init operation panel object
        opPanel = operation.OpPanel(self.Panel, main, params)

        self.insertOperation(n, opPanel)
        return opPanel


    ## == View related methods == ##

    def destroyAllOperations(self):
        for n in range(len(self.operations)):
            self.operations[n].Destroy()
        self.operations = []

    def moveOperations(self, n, moveTo):
        oldPanel = self.operations[n]
        del self.operations[n]
        self.operations.insert(moveTo, oldPanel)

    def deleteOperation(self, n):
        self.operations[n].Destroy()
        del self.operations[n]

    def insertOperation(self, n, opPanel):
        self.operations.insert(n, opPanel)


    ## == Renaming related methods == ##

    def previewItems(self, event):
        self.Preview.setup()
        self.Preview.generateNames(event)

    def errorCheckItems(self):
        self.Preview.setup()
        self.Preview.errorCheckItems()

    def renameItems(self, event):
        self.Engine.setup()
        self.Engine.renameItems(event)

    def undoRename(self, event):
        self.Engine.setup()
        self.Engine.undoLastRename(event)
